
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 CLR_NONE
#property indicator_color2 CLR_NONE
#property indicator_color3 Black

extern string TimeFrame = "D1";
extern int RsiPeriod = 4;
extern int MaType = 1;
extern int MaPeriod = 2;
extern bool Interpolate = TRUE;
extern string arrowsIdentifier = "RsiEmaArrows";
extern color arrowsUpColor = Lime;
extern color arrowsDnColor = Fuchsia;
extern bool alertsOn = TRUE;
extern bool alertsSound = TRUE;
extern bool alertsOnCurrent = FALSE;
extern bool alertsMessage = FALSE;
extern bool alertsEmail = FALSE;
double G_ibuf_136[];
double G_ibuf_140[];
double G_ibuf_144[];
string Gs_148;
bool Gi_156 = FALSE;
bool Gi_160 = FALSE;
int G_timeframe_164;
string Gs_nothing_168 = "nothing";
datetime G_time_176;

// E37F0136AA3FFAF149B351F6A4C948E9
int init() {
//   string Ls_0 = "2013.12.30";
//   int str2time_8 = StrToTime(Ls_0);
//   if (TimeCurrent() >= str2time_8) {
//      Alert("Maaf PAKARENA PASTI PROFIT Sudah Expire! Silahkan Inbox diFB Sumarjan Toguna ");
//      return (0);
//   }
   IndicatorBuffers(3);
   SetIndexBuffer(0, G_ibuf_136);
   SetIndexLabel(0, "rsi");
   SetIndexBuffer(1, G_ibuf_140);
   SetIndexLabel(1, "ema");
   SetIndexBuffer(2, G_ibuf_144);
   SetIndexLabel(2, "trend");
   if (TimeFrame == "calculate") {
      Gi_156 = TRUE;
      return (0);
   }
   if (TimeFrame == "returnBars") {
      Gi_160 = TRUE;
      return (0);
   }
   G_timeframe_164 = f0_3(TimeFrame);
   Gs_148 = WindowExpertName();
   IndicatorShortName("pakarena pasti profit " + f0_0());
   return (0);
}

// 52D46093050F38C27267BCE42543EF60
int deinit() {
   f0_2();
   return (0);
}

// EA2B2676C28C0DB26D39331A336C6B92
int start() {
   int shift_12;
   int datetime_16;
   double Ld_24;
   int Li_36;
   int Li_0 = IndicatorCounted();
   if (Li_0 < 0) return (-1);
   if (Li_0 > 0) Li_0--;
   int Li_8 = MathMin(Bars - Li_0, Bars - 1);
   if (Gi_160) {
      G_ibuf_136[0] = Li_8 + 1;
      return (0);
   }
   if (G_timeframe_164 > Period()) Li_8 = MathMax(Li_8, MathMin(Bars - 1, iCustom(NULL, G_timeframe_164, Gs_148, "returnBars", 0, 0) * G_timeframe_164 / Period()));
   if (Gi_156) {
      for (int Li_4 = 0; Li_4 < Li_8; Li_4++) G_ibuf_136[Li_4] = iRSI(NULL, 0, RsiPeriod, PRICE_CLOSE, Li_4);
      for (Li_4 = 0; Li_4 < Li_8; Li_4++) G_ibuf_140[Li_4] = iMAOnArray(G_ibuf_136, 0, MaPeriod, 0, MaType, Li_4);
      return (0);
   }
   for (Li_4 = Li_8; Li_4 >= 0; Li_4--) {
      shift_12 = iBarShift(NULL, G_timeframe_164, Time[Li_4]);
      G_ibuf_136[Li_4] = iCustom(NULL, G_timeframe_164, Gs_148, "calculate", RsiPeriod, MaType, MaPeriod, 0, shift_12);
      G_ibuf_140[Li_4] = iCustom(NULL, G_timeframe_164, Gs_148, "calculate", RsiPeriod, MaType, MaPeriod, 1, shift_12);
      G_ibuf_144[Li_4] = G_ibuf_144[Li_4 + 1];
      if (G_ibuf_136[Li_4] > G_ibuf_140[Li_4]) G_ibuf_144[Li_4] = 1;
      if (G_ibuf_136[Li_4] < G_ibuf_140[Li_4]) G_ibuf_144[Li_4] = -1;
      if (G_ibuf_144[Li_4] != G_ibuf_144[Li_4 + 1]) {
         if (G_ibuf_144[Li_4] == 1.0) f0_1(Li_4, arrowsUpColor, 236, 0);
         if (G_ibuf_144[Li_4] == -1.0) f0_1(Li_4, arrowsDnColor, 238, 1);
      }
      if (G_timeframe_164 <= Period() || shift_12 == iBarShift(NULL, G_timeframe_164, Time[Li_4 - 1])) continue;
      if (Interpolate) {
         datetime_16 = iTime(NULL, G_timeframe_164, shift_12);
         for (int Li_20 = 1; Li_4 + Li_20 < Bars && Time[Li_4 + Li_20] >= datetime_16; Li_20++) {
         }
         Ld_24 = 1.0 / Li_20;
         for (int Li_32 = 1; Li_32 < Li_20; Li_32++) {
            G_ibuf_136[Li_4 + Li_32] = Li_32 * Ld_24 * (G_ibuf_136[Li_4 + Li_20]) + (1.0 - Li_32 * Ld_24) * G_ibuf_136[Li_4];
            G_ibuf_140[Li_4 + Li_32] = Li_32 * Ld_24 * (G_ibuf_140[Li_4 + Li_20]) + (1.0 - Li_32 * Ld_24) * G_ibuf_140[Li_4];
         }
      }
   }
   if (alertsOn) {
      if (alertsOnCurrent) Li_36 = 0;
      else Li_36 = 1;
      if (G_ibuf_144[Li_36] != G_ibuf_144[Li_36 + 1]) {
         if (G_ibuf_144[Li_36] == 1.0) f0_4("up");
         if (G_ibuf_144[Li_36] == -1.0) f0_4("down");
      }
   }
   return (0);
}

// 8D889266138297DD92247DFDC01E6723
void f0_1(int Ai_0, color A_color_4, int Ai_8, bool Ai_12) {
   string name_16 = arrowsIdentifier + ":" + Time[Ai_0];
   double Ld_24 = 6.0 * iATR(NULL, 0, 20, Ai_0) / 4.0;
   ObjectCreate(name_16, OBJ_ARROW, 0, Time[Ai_0], 0);
   ObjectSet(name_16, OBJPROP_ARROWCODE, Ai_8);
   ObjectSet(name_16, OBJPROP_COLOR, A_color_4);
   if (Ai_12) {
      ObjectSet(name_16, OBJPROP_PRICE1, High[Ai_0] + Ld_24);
      return;
   }
   ObjectSet(name_16, OBJPROP_PRICE1, Low[Ai_0] - Ld_24);
}

// B4CC322FC1B58ED8264BB2FA751F8C0A
void f0_2() {
   string name_16;
   string Ls_0 = arrowsIdentifier + ":";
   int str_len_8 = StringLen(Ls_0);
   for (int Li_12 = ObjectsTotal() - 1; Li_12 >= 0; Li_12--) {
      name_16 = ObjectName(Li_12);
      if (StringSubstr(name_16, 0, str_len_8) == Ls_0) ObjectDelete(name_16);
   }
}

// DA717D55A7C333716E8D000540764674
void f0_4(string As_0) {
   string str_concat_8;
   if (Gs_nothing_168 != As_0 || G_time_176 != Time[0]) {
      Gs_nothing_168 = As_0;
      G_time_176 = Time[0];
      str_concat_8 = StringConcatenate(Symbol(), " at ", TimeToStr(TimeLocal(), TIME_SECONDS), " RSI crossed EMA ", As_0);
      if (alertsMessage) Alert(str_concat_8);
      if (alertsEmail) SendMail(StringConcatenate(Symbol(), "RsiEma"), str_concat_8);
      if (alertsSound) PlaySound("pasti profit.wav");
   }
}

// B9EDCDEA151586E355292E7EA9BE516E
int f0_3(string As_0) {
   int Li_12;
   for (int Li_8 = StringLen(As_0) - 1; Li_8 >= 0; Li_8--) {
      Li_12 = StringGetChar(As_0, Li_8);
      if ((Li_12 > '`' && Li_12 < '{') || (Li_12 > '' && Li_12 < 256)) As_0 = StringSetChar(As_0, Li_8, Li_12 - 32);
      else
         if (Li_12 > -33 && Li_12 < 0) As_0 = StringSetChar(As_0, Li_8, Li_12 + 224);
   }
   int timeframe_16 = 0;
   if (As_0 == "M1" || As_0 == "1") timeframe_16 = 1;
   if (As_0 == "M5" || As_0 == "5") timeframe_16 = 5;
   if (As_0 == "M15" || As_0 == "15") timeframe_16 = 15;
   if (As_0 == "M30" || As_0 == "30") timeframe_16 = 30;
   if (As_0 == "H1" || As_0 == "60") timeframe_16 = 60;
   if (As_0 == "H4" || As_0 == "240") timeframe_16 = 240;
   if (As_0 == "D1" || As_0 == "1440") timeframe_16 = 1440;
   if (As_0 == "W1" || As_0 == "10080") timeframe_16 = 10080;
   if (As_0 == "MN" || As_0 == "43200") timeframe_16 = 43200;
   if (timeframe_16 == 0 || timeframe_16 < Period()) timeframe_16 = Period();
   return (timeframe_16);
}

// 114D6A415B3D04DB792CA7C0DA0C7A55
string f0_0() {
   switch (G_timeframe_164) {
   case PERIOD_M1:
      return ("M(1)");
   case PERIOD_M5:
      return ("M(5)");
   case PERIOD_M15:
      return ("M(15)");
   case PERIOD_M30:
      return ("M(30)");
   case PERIOD_H1:
      return ("H(1)");
   case PERIOD_H4:
      return ("H(4)");
   case PERIOD_D1:
      return ("D(1)");
   case PERIOD_W1:
      return ("W(1)");
   case PERIOD_MN1:
      return ("MN(1)");
   }
   return ("Unknown timeframe");
}